/*
 * Copyright (c) 2012 Allan Wirth <allan@allanwirth.com>
 * 
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

(function() {
  var title_change = (function(arg) {
    var msg; 
    switch(arg) {
    default:
      msg = "Inited";
      break;
    case -1:
    case 0:
      msg = "Stopped";
      break;
    case 1:
      msg = "Playing";
      break;
    case 3:
    case 2:
      msg = "Paused";
      break;
    }
    window.document.title = msg + " - " + (new Date().getTime());
  }), err = (function(arg) {
    title_change(-1);
  }), settedUp = false, setup = (function() {
    if (settedUp) {
      return;
    }
    settedUp = true;
    var old1 = ytPlayeronStateChange2;
    ytPlayeronStateChange2 = (function(arg) {
      old1(arg);
      title_change(arg);
    });
    var old2 = ytPlayeronError2;
    ytPlayeronError2 = (function(arg) {
      old2(arg);
      err(arg);
    });
    title_change();
  }), trySetup = (function() {
    if (typeof(ytPlayeronStateChange2) != "undefined") {
      setup();
      return true;
    } else {
      return false;
    }
  }), retrySetup = (function() {
    if (!trySetup()) {
      setTimeout(retrySetup, 0);
    }
  });
  retrySetup();
})();
