#!/usr/bin/python
# Copyright (c) 2012 Allan Wirth <allan@allanwirth.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

"""Simple youtube test window. Pass command line arg."""

import gtk
import os
import sys

sys.path.insert(0, os.path.join(os.path.dirname(__file__), ".."))

from src.backends.youtube import youtube

def main(url):
  yid = youtube.get_youtube_id(url)

  if (yid == ""):
    print "Not a youtube url!"
    return

  w = gtk.Window()
  yt = youtube.YoutubeWidget()
  w.add(yt)

  w.show_all()

  yt.load_id(yid, "small")

  w.connect("destroy-event", lambda x,y: gtk.main_quit())
  yt.connect("stopped", lambda x: gtk.main_quit())

  gtk.main()

if __name__ == "__main__":
  import sys
  if (len(sys.argv) < 2):
    print "Command line argument required!"
  else:
    main(sys.argv[1])
