# Copyright (c) 2012 George Silvis, III <george.iii.silvis@gmail.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

"""Functions for handling for Bandcamp interaction."""

import json
import re
import urllib2
  
def get_bandcamp_track_url(url):
  try:
    page = urllib2.urlopen(url)
    contents = page.read()
    match = re.search("trackinfo: \\[(.*)\\]", contents)
    json_string = match.group(1)
    json_stuff = json.loads(json_string)
    streaming_url = json_stuff["file"]
    return streaming_url
  except:
    return None


def get_bandcamp_metadata(url):
  try:
    page = urllib2.urlopen(url)
    contents = page.read()
    match = re.search("trackinfo: \\[(.*)\\]", contents)
    json_string = match.group(1)
    json_stuff = json.loads(json_string)

    metadata = {'video': False}
    metadata['title'] = json_stuff['title']
    metadata['duration'] = int(json_stuff['duration'] * 1000)

    try:
      match1 = re.search("album_title : (.*),", contents)
      fake_json_string1 = '{"album" : ' + match1.group(1) + '}'
      fake_json_stuff1 = json.loads(fake_json_string1)
      metadata.update(fake_json_stuff1)
    except:
      pass

    try:
      match2 = re.search("artist : (.*),", contents)
      fake_json_string2 = '{"artist" : ' + match2.group(1) + '}'
      fake_json_stuff2 = json.loads(fake_json_string2)
      metadata.update(fake_json_stuff2)
    except:
      pass

    return metadata
  except Exception as e:
    print e
    return None
