# Copyright (c) 2012 Allan Wirth <allan@allanwirth.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

import mimetypes
import subprocess

"""Text to Speech requires 'festival' to be installed"""

def isText(url):  
  if url.startswith("speech://"):
    return True
  elif url.startswith("file://"):
    t = mimetypes.guess_type(url)
    return t[0] is not None and "text" in t[0]
  else:
    return False

def getWav(url, output):
  if (url.startswith("speech://")):
    p1 = subprocess.Popen(["echo",url[9:]], stdout=subprocess.PIPE)
  else:
    p1 = subprocess.Popen(["cat", url[7:]], stdout=subprocess.PIPE)
  p2 = subprocess.Popen(["text2wave","-o",output], stdin=p1.stdout)
  p2.communicate()

def getMetadata(url):
  meta = {"video": False}
  if url.startswith("speech://"):
    meta["title"] = url[9:]
  else:
    meta["title"] = "Spoken Word"
  return meta
