# Copyright (c) 2012 Allan Wirth <allan@allanwirth.com>
#
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation
# files (the "Software"), to deal in the Software without
# restriction, including without limitation the rights to use,
# copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following
# conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
# OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
# HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
# WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
# OTHER DEALINGS IN THE SOFTWARE.

"""Functions for handling for xHamster interaction."""

import urllib2
import re

XHAMSTER_URL = "http://xhamster.com/movies/{0}/.html"

def get_xhamster_id(url):
  match = re.search(r"xhamster\.com/movies/([0-9]+)/", url)
  if match is None:
    return ""
  else:
    return match.group(1)

def get_xhamster_video_url(url):
  id = get_xhamster_id(url)
  url = XHAMSTER_URL.format(id)

  try:
    page = urllib2.urlopen(url)
    contents = page.read()
    match1 = re.search("'srv': '(.+?)'", contents)
    match2 = re.search("'file': '(.+?)'", contents)
    return match1.group(1) + '/key=' + match2.group(1)
  except:
    return None

def get_xhamster_metadata(url):
  id = get_xhamster_id(url)
  url = XHAMSTER_URL.format(id)

  result = {'video': True}

  try:
    page = urllib2.urlopen(url)
    contents = page.read()
    match = re.search("<title>(.+?) - xHamster.com</title>", contents)
    result["title"] = match.group(1)
  except:
    pass
  return result
